# -*- tcl -*-
# Specific timing constraints for the WRCore/Streamers/LPDC. General-cores CDC stuff is not included, check the
# automatically-generated gencores_constraints.xdc for these

# DDMTDs
set ddmtd_max_delay 2.0

set_max_delay -datapath_only -from [ get_ports clk_ext_62m_p_i ] -to [  get_pins -hier -filter { name=~*U_Sampler/*clk_i_d0_reg/D } ] $ddmtd_max_delay
set_max_delay -datapath_only -from [ get_ports clk_ext_10m_p_i ] -to [  get_pins -hier -filter { name=~*U_Sampler/*clk_i_d0_reg/D } ] $ddmtd_max_delay
set_max_delay -datapath_only -from [ get_ports clk_ref_p_i ] -to [  get_pins -hier -filter { name=~*U_Sampler/*clk_i_d0_reg/D } ] $ddmtd_max_delay
set_max_delay -datapath_only -from [ get_ports clk_ref_p_i ] -to [  get_pins -hier -filter { name=~*U_Sampler_REFCLK/gen_straight.clk_i_d0_reg/D } ] $ddmtd_max_delay
set_max_delay -datapath_only -from [ get_pins -hier -filter { name =~*inst_the_gtx/gtxe2_i/TXOUTCLK } ] -to [  get_pins -hier -filter { name=~*U_Sampler_TX/gen_straight.clk_i_d0_reg/D } ] $ddmtd_max_delay
set_max_delay -datapath_only -from [ get_pins -hier -filter { name =~*inst_the_gtx/gtxe2_i/RXOUTCLK } ] -to [  get_pins -hier -filter { name=~*U_Sampler_RX/gen_straight.clk_i_d0_reg/D } ] $ddmtd_max_delay

# wbgen shit
set_max_delay -datapath_only -from [ get_cells -hier -filter { name=~*_int_reg } ] -to [  get_cells -hier -filter { name=~*_sync0_reg } ] 16.00
set_max_delay -datapath_only -from [ get_cells -hier -filter { name=~*_lwb_reg } ] -to [  get_cells -hier -filter { name=~*_lwb_s0_reg } ] 16.00
set_max_delay -datapath_only -from [ get_cells -hier -filter { name=~*_lw_reg } ] -to [  get_cells -hier -filter { name=~*_lw_s0_reg } ] 16.00

# xwr_softpll_ng
set_max_delay -datapath_only -from [ get_pins -hier -filter { name=~*U_SOFTPLL/U_Wrapped_Softpll/gen_with_ext_clock_input.U_Aligner_EXT/sample_cin_o_reg[*]/C } ] -to [ get_pins -hier -filter { name=~*U_SOFTPLL/U_Wrapped_Softpll/regs_out_reg[al_cin_i][*]/D } ] 10.0
set_max_delay -datapath_only -from [ get_pins -hier -filter { name=~*U_SOFTPLL/U_Wrapped_Softpll/gen_with_ext_clock_input.U_Aligner_EXT/sample_cref_o_reg[*]/C } ] -to [ get_pins -hier -filter { name=~*U_SOFTPLL/U_Wrapped_Softpll/regs_out_reg[al_cref_i][*]/D } ] 10.0
set_max_delay -datapath_only -from [ get_pins -hier -filter { name=~*U_SOFTPLL/U_Wrapped_Softpll/gen_with_ext_clock_input.U_Aligner_EXT/cnt_in_gray_reg[*]/C } ] -to [ get_pins -hier -filter { name=~*U_SOFTPLL/U_Wrapped_Softpll/gen_with_ext_clock_input.U_Aligner_EXT/cnt_in_gray_x_reg[*]/D } ] 4.0
set_max_delay -datapath_only -from [ get_pins -hier -filter { name=~*U_SOFTPLL/U_Wrapped_Softpll/*DMTD*/tag_o_reg[*]/C } ] -to [ get_pins -hier -filter { name=~*U_SOFTPLL/U_Wrapped_Softpll/tags_masked_reg[*][*]/D } ] 10.0
set_false_path -from [ get_cells -hier -filter { name=~*U_SOFTPLL/U_Wrapped_Softpll/U_WB_SLAVE/spll_deglitch_thr_int_reg* } ]

# xwb_clock_monitor
set_false_path -to [ get_pins -hier -filter { name=~*clks_reg[*][presc_cnt][*]/CLR } ]
set_false_path -to [ get_pins -hier -filter { name=~*clks_reg[*][clk_presc]/CLR } ]
set_false_path -from [ get_cells -hier -filter { name=~*U_WB_Slave/cm_cr_presc_int_reg* } ]

# PHY
set_false_path -from [ get_cells -hier -filter { name=~*U_LPDC_regs/CTRL_dmtd_clk_sel_reg_reg* } ]
set_false_path -from [ get_cells -hier -filter { name=~*U_LPDC_regs/CTRL2_rx_rate_reg_reg[*] } ]
set_false_path -to [ get_pins -hier -filter { name=~*U_GTX_Link0/rx_cdr_lock_filtered_reg/CLR } ]
set_false_path -to [ get_pins -hier -filter { name=~*U_GTX_Link0/rxcdrlock_cnt_reg[*]/CLR } ]
set_false_path -from [ get_cells -hier -filter { name=~*U_GTX_Link0/inst_idle_detect/pat_value_o_reg[*] } ]

# xwr_streamers
set_false_path -from [ get_cells -hier -filter { name=~*U_WB/wr_streamers_rx_cfg6_rx_fixed_latency_timeout_int_reg[*] } ]
set_false_path -from [ get_cells -hier -filter { name=~*U_WB/wr_streamers_cfg_or_rx_fix_lat_int_reg } ]
set_false_path -from [ get_cells -hier -filter { name=~*U_WB/wr_streamers_rx_cfg5_fixed_latency_int_reg[*] } ]
set_false_path -to [ get_cells -hier -filter { name =~*gen_with_dbg_word.dbg_word_reg[*] } ]
set_max_delay -datapath_only -from [ get_pins -hier -filter { name=~*U_STATS/U_Reset_Timestamper/tag_cycles_ref_reg[*]/C } ] -to [ get_pins -hier -filter { name=~*U_STATS/U_Reset_Timestamper/tag_cycles_o_reg[*]/D } ] 10.0
set_max_delay -datapath_only -from [ get_pins -hier -filter { name=~*U_STATS/U_Reset_Timestamper/tag_utc_ref_reg[*]/C } ] -to [ get_pins -hier -filter { name=~*U_STATS/U_Reset_Timestamper/tag_tai_o_reg[*]/D } ] 10.0
set_max_delay -datapath_only -from [ get_pins -hier -filter { name=~*U_RX/U_RX_Timestamper/tag_cycles_ref_reg[*]/C } ] -to [ get_pins -hier -filter { name=~*U_RX/U_RX_Timestamper/tag_cycles_o_reg[*]/D } ] 10.0
set_max_delay -datapath_only -from [ get_cells -hier -filter { name=~*/U_RestoreTAITimeFromRXTimestamp/tm_tai_ref_reg[*] } ] -to [ get_cells -hier -filter { name=~*/U_RestoreTAITimeFromRXTimestamp/tm_tai_sys_reg[*] } ] 10.0
set_max_delay -datapath_only -from [ get_cells -hier -filter { name=~*/U_RestoreTAITimeFromRXTimestamp/tm_cycles_ref_reg[*] } ] -to [ get_cells -hier -filter { name=~*/U_RestoreTAITimeFromRXTimestamp/tm_cycles_sys_reg[*] } ] 10.0
set_max_delay -datapath_only -from [ get_cells -hier -filter { name=~*/U_RestoreTAITimeFromRXTimestamp/tm_valid_ref_reg* } ] -to [  get_cells -hier -filter { name=~*/U_RestoreTAITimeFromRXTimestamp/tm_valid_sys_reg } ] 16.00

#fixme: ugly, we need to identify the FIFO cells using Distributed RAM instead of wildcarding
set_max_delay -datapath_only -from [ get_pins -hier -filter { name=~*U_Inferred_FIFO/mem_reg_*/RAM*/CLK } ] -to [ get_pins -hier -filter { name=~*U_Inferred_FIFO/q_int_reg[*]/D} ] 16.0

# PPSGen
set_max_delay -datapath_only -from [ get_cells -hier -filter { name=~*/WRAPPED_PPSGEN/adj_nsec_reg[*] } ] -to [  get_cells -hier -filter { name=~*/WRAPPED_PPSGEN/cntr_nsec_reg[*] } ] 16.00
set_max_delay -datapath_only -from [ get_cells -hier -filter { name=~*/WRAPPED_PPSGEN/adj_utc_reg[*] } ] -to [  get_cells -hier -filter { name=~*/WRAPPED_PPSGEN/cntr_utc_reg[*] } ] 16.00
set_max_delay -datapath_only -from [ get_pins -hier -filter { name=~*/WRAPPED_PPSGEN/Uwb_slave/ppsg_cntr_nsec_int_reg[*]/C } ] -to [  get_cells -hier -filter { name=~*/WRAPPED_PPSGEN/Uwb_slave/rddata_reg_reg[*] } ] 16.00
set_max_delay -datapath_only -from [ get_pins -hier -filter { name=~*/WRAPPED_PPSGEN/Uwb_slave/ppsg_cntr_utchi_int_reg[*]/C } ] -to [  get_cells -hier -filter { name=~*/WRAPPED_PPSGEN/Uwb_slave/rddata_reg_reg[*] } ] 16.00
set_max_delay -datapath_only -from [ get_cells -hier -filter { name=~*/WRAPPED_PPSGEN/Uwb_slave/ppsg_cntr_utclo_int_reg* } ] -to [  get_cells -hier -filter { name=~*/WRAPPED_PPSGEN/Uwb_slave/rddata_reg_reg* } ] 16.00
set_max_delay -datapath_only -from [ get_pins -hier -filter { name=~*/WRAPPED_PPSGEN/Uwb_slave/ppsg_cr_cnt_adj_int_read_reg/C } ] -to [  get_cells -hier -filter { name=~*/WRAPPED_PPSGEN/Uwb_slave/rddata_reg_reg[*] } ] 16.00
set_max_delay -datapath_only -from [ get_cells -hier -filter { name=~*/WRAPPED_PPSGEN/Uwb_slave/ppsg_cr_cnt_adj_int_write_reg* } ] -to [  get_cells -hier -filter { name=~*/WRAPPED_PPSGEN/Uwb_slave/ppsg_cr_cnt_adj_o_reg } ] 16.00
set_max_delay -datapath_only -from [ get_cells -hier -filter { name=~*/WRAPPED_PPSGEN/Uwb_slave/ppsg_cr_cnt_adj_rwsel_reg* } ] -to [  get_cells -hier -filter { name=~*/WRAPPED_PPSGEN/Uwb_slave/ppsg_cr_cnt_adj_int_read_reg } ] 16.00
set_max_delay -datapath_only -from [ get_cells -hier -filter { name=~*/WRAPPED_PPSGEN/Uwb_slave/ppsg_cr_cnt_adj_rwsel_reg } ] -to [  get_cells -hier -filter { name=~*/WRAPPED_PPSGEN/Uwb_slave/ppsg_cr_cnt_adj_load_o_reg } ] 16.00
set_max_delay -datapath_only -from [ get_cells -hier -filter { name=~*/WRAPPED_PPSGEN/Uwb_slave/ppsg_cr_cnt_adj_rwsel_reg* } ] -to [  get_cells -hier -filter { name=~*/WRAPPED_PPSGEN/Uwb_slave/ppsg_cr_cnt_adj_o_reg } ] 16.00
set_max_delay -datapath_only -from [ get_cells -hier -filter { name=~*/WRAPPED_PPSGEN/Uwb_slave/ppsg_cr_cnt_adj_rwsel_reg* } ] -to [  get_cells -hier -filter { name=~*/WRAPPED_PPSGEN/Uwb_slave/ppsg_escr_sync_int_read_reg } ] 16.00
set_max_delay -datapath_only -from [ get_cells -hier -filter { name=~*/WRAPPED_PPSGEN/Uwb_slave/ppsg_cr_pwidth_int_reg[*] } ] -to [  get_cells -hier -filter { name=~*/WRAPPED_PPSGEN/Uwb_slave/ppsg_cr_pwidth_o_reg[*] } ] 16.00
set_max_delay -datapath_only -from [ get_cells -hier -filter { name=~*/WRAPPED_PPSGEN/Uwb_slave/ppsg_cr_pwidth_swb_reg } ] -to [  get_cells -hier -filter { name=~*/WRAPPED_PPSGEN/Uwb_slave/ppsg_cr_pwidth_swb_s0_reg } ] 16.00
set_max_delay -datapath_only -from [ get_cells -hier -filter { name=~*/WRAPPED_PPSGEN/Uwb_slave/ppsg_escr_sync_int_read_reg* } ] -to [  get_cells -hier -filter { name=~*/WRAPPED_PPSGEN/Uwb_slave/rddata_reg_reg[*] } ] 16.00
set_max_delay -datapath_only -from [ get_cells -hier -filter { name=~*/WRAPPED_PPSGEN/Uwb_slave/ppsg_escr_sync_int_write_reg* } ] -to [  get_cells -hier -filter { name=~*/WRAPPED_PPSGEN/Uwb_slave/ppsg_escr_sync_o_reg } ] 16.00
set_max_delay -datapath_only -from [ get_cells -hier -filter { name=~*/WRAPPED_PPSGEN/Uwb_slave/ppsg_escr_sync_rwsel_reg* } ] -to [  get_cells -hier -filter { name=~*/WRAPPED_PPSGEN/Uwb_slave/ppsg_escr_sync_int_read_reg } ] 16.00
set_max_delay -datapath_only -from [ get_cells -hier -filter { name=~*/WRAPPED_PPSGEN/Uwb_slave/ppsg_escr_sync_rwsel_reg } ] -to [  get_cells -hier -filter { name=~*/WRAPPED_PPSGEN/Uwb_slave/ppsg_escr_sync_load_o_reg } ] 16.00
set_max_delay -datapath_only -from [ get_cells -hier -filter { name=~*/WRAPPED_PPSGEN/Uwb_slave/ppsg_escr_sync_rwsel_reg* } ] -to [  get_cells -hier -filter { name=~*/WRAPPED_PPSGEN/Uwb_slave/ppsg_escr_sync_o_reg } ] 16.00

# xwb_fine_pulse_gen
set_false_path -from [ get_cells -hier -filter { name =~*U_DDSSyncUnit/U_Regs/OCR*_FINE_reg_reg[*] } ]
set_false_path -from [ get_cells -hier -filter { name =~*U_DDSSyncUnit/U_Regs/OCR*_POL_reg_reg } ]
set_false_path -from [ get_cells -hier -filter { name =~*U_DDSSyncUnit/U_Regs/OCR*_PPS_OFFS_reg_reg[*] } ]
set_false_path -from [ get_cells -hier -filter { name =~*U_DDSSyncUnit/U_Regs/OCR*_LENGTH_reg_reg[*] } ]
set_false_path -from [ get_cells -hier -filter { name =~*U_DDSSyncUnit/U_Regs/csr_SERDES_RST_reg_reg } ]
set_false_path -from [ get_cells -hier -filter { name =~*U_DDSSyncUnit/U_Regs/OCR*_COARSE_reg_reg[*] } ]
set_false_path -from [ get_cells -hier -filter { name =~*U_DDSSyncUnit/U_Regs/OCR*_CONT_reg_reg } ]
set_false_path -from [ get_cells -hier -filter { name =~*U_DDSSyncUnit/U_Regs/OCR*_TRIG_SEL_reg_reg } ]

# xwr_endpoint
set_max_delay -datapath_only -from [ get_cells -hier -filter { name=~*/U_EP_TSU/cntr_rx_f_reg[*] } ] -to [ get_cells -hier -filter { name=~*/U_EP_TSU/rxts_timestamp_o_reg[*] } ] 16.0
set_max_delay -datapath_only -from [ get_cells -hier -filter { name=~*/U_EP_TSU/cntr_rx_r_reg[*] } ] -to [ get_cells -hier -filter { name=~*/U_EP_TSU/rxts_timestamp_o_reg[*] } ] 16.00
set_max_delay -datapath_only -from [ get_cells -hier -filter { name=~*/U_EP_TSU/cntr_tx_f_reg[*] } ] -to [ get_cells -hier -filter { name=~*/U_EP_TSU/txts_timestamp_o_reg[*] } ] 16.00
set_max_delay -datapath_only -from [ get_cells -hier -filter { name=~*/U_EP_TSU/cntr_tx_r_reg[*] } ] -to [ get_cells -hier -filter { name=~*/U_EP_TSU/txts_timestamp_o_reg[*] } ] 16.00
set_max_delay -datapath_only -from [ get_cells -hier -filter { name=~*/U_EP_TSU/valid_rx_reg } ] -to [  get_cells -hier -filter { name=~*/U_EP_TSU/rxts_timestamp_valid_o_reg } ] 16.00
set_max_delay -datapath_only -from [ get_cells -hier -filter { name=~*/U_EP_TSU/valid_tx_reg } ] -to [  get_cells -hier -filter { name=~*/U_EP_TSU/txts_timestamp_valid_o_reg } ] 16.00
set_max_delay -datapath_only -from [ get_pins -hier -filter { name=~*/U_Wrapped_Endpoint/U_WB_SLAVE/ep_tscr_cs_done_sync1_reg/C } ] -to [  get_cells -hier -filter { name=~*/U_Wrapped_Endpoint/U_WB_SLAVE/rddata_reg_reg[*] } ] 16.00
set_max_delay -datapath_only -from [ get_cells -hier -filter { name=~*/U_EP_TSU/cntr_rx_*_reg[*] } ] -to [  get_pins -hier -filter { name=~*/U_EP_TSU/regs_o_tscr_rx_cal_result_rx_clk_reg/D } ] 16.00
set_max_delay -datapath_only -from [ get_cells -hier -filter { name=~*/U_Rx_Path/gen_with_packet_filter.U_packet_filter/drop_int* } ] -to [  get_cells -hier -filter { name=~*/U_Rx_Path/gen_with_packet_filter.U_packet_filter/drop_o_reg } ] 16.00
set_max_delay -datapath_only -from [ get_cells -hier -filter { name=~*/U_Rx_Path/gen_with_packet_filter.U_packet_filter/pclass_int* } ] -to [  get_cells -hier -filter { name=~*/U_Rx_Path/gen_with_packet_filter.U_packet_filter/pclass_o_reg[*] } ] 16.00


